"use strict";

const conversions = require("webidl-conversions");
const utils = require("./utils.js");

const implSymbol = utils.implSymbol;
const ctorRegistrySymbol = utils.ctorRegistrySymbol;

const interfaceName = "Screen";

exports.is = value => {
    return utils.isObject(value) && utils.hasOwn(value, implSymbol) && value[implSymbol] instanceof Impl.implementation;
};
exports.isImpl = value => {
    return utils.isObject(value) && value instanceof Impl.implementation;
};
exports.convert = (value, {context = "The provided value"} = {}) => {
    if (exports.is(value)) {
        return utils.implForWrapper(value);
    }
    throw new TypeError(`${context} is not of type 'Screen'.`);
};

function makeWrapper(globalObject) {
    if (globalObject[ctorRegistrySymbol] === undefined) {
        throw new Error("Internal error: invalid global object");
    }

    const ctor = globalObject[ctorRegistrySymbol]["Screen"];
    if (ctor === undefined) {
        throw new Error("Internal error: constructor Screen is not installed on the passed global object");
    }

    return Object.create(ctor.prototype);
}

exports.create = (globalObject, constructorArgs, privateData) => {
    const wrapper = makeWrapper(globalObject);
    return exports.setup(wrapper, globalObject, constructorArgs, privateData);
};

exports.createImpl = (globalObject, constructorArgs, privateData) => {
    const wrapper = exports.create(globalObject, constructorArgs, privateData);
    return utils.implForWrapper(wrapper);
};

exports._internalSetup = (wrapper, globalObject) => {
};

exports.setup = (wrapper, globalObject, constructorArgs = [], privateData = {}) => {
    privateData.wrapper = wrapper;

    exports._internalSetup(wrapper, globalObject);
    Object.defineProperty(wrapper, implSymbol, {
        value: new Impl.implementation(globalObject, constructorArgs, privateData),
        configurable: true
    });

    wrapper[implSymbol][utils.wrapperSymbol] = wrapper;
    if (Impl.init) {
        Impl.init(wrapper[implSymbol]);
    }
    return wrapper;
};

exports.new = globalObject => {
    const wrapper = makeWrapper(globalObject);

    exports._internalSetup(wrapper, globalObject);
    Object.defineProperty(wrapper, implSymbol, {
        value: Object.create(Impl.implementation.prototype),
        configurable: true
    });

    wrapper[implSymbol][utils.wrapperSymbol] = wrapper;
    if (Impl.init) {
        Impl.init(wrapper[implSymbol]);
    }
    return wrapper[implSymbol];
};

const exposed = new Set(["Window"]);

exports.install = (globalObject, globalNames) => {
    if (!globalNames.some(globalName => exposed.has(globalName))) {
        return;
    }

    class Screen {
        constructor() {
            throw new TypeError("Illegal constructor");
        }

        get availWidth() {
            console.log('availWidth', window.fingerprint.screen.availWidth)
            // return 1920;
            return window.fingerprint.screen.availWidth;

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get availWidth' called on an object that is not a valid instance of Screen.");
            }

            return esValue[implSymbol]["availWidth"];
        }

        get availHeight() {
            console.log('availHeight', window.fingerprint.screen.availHeight)
            // return 1080;
            return window.fingerprint.screen.availHeight;

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get availHeight' called on an object that is not a valid instance of Screen.");
            }

            return esValue[implSymbol]["availHeight"];
        }

        get width() {
            console.log('width', window.fingerprint.screen.width)

            return window.fingerprint.screen.width;

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get width' called on an object that is not a valid instance of Screen.");
            }

            return esValue[implSymbol]["width"];
        }

        get height() {
            console.log('height', window.fingerprint.screen.height)

            return window.fingerprint.screen.height;

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get height' called on an object that is not a valid instance of Screen.");
            }

            return esValue[implSymbol]["height"];
        }

        get colorDepth() {
            return window.fingerprint.screen.colorDepth;

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get colorDepth' called on an object that is not a valid instance of Screen.");
            }

            return esValue[implSymbol]["colorDepth"];
        }

        get pixelDepth() {
            return window.fingerprint.screen.pixelDepth;
            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get pixelDepth' called on an object that is not a valid instance of Screen.");
            }

            return esValue[implSymbol]["pixelDepth"];
        }

        get availTop() {
            return window.fingerprint.screen.availTop
        }

        get availLeft() {
            return window.fingerprint.screen.availLeft
        }

        get innerHeight() {
            return window.fingerprint.screen.innerHeight
        }

        get outerHeight() {
            return window.fingerprint.screen.outerHeight
        }

        get outerWidth() {
            return window.fingerprint.screen.outerWidth
        }

        get innerWidth() {
            return window.fingerprint.screen.innerWidth
        }

        get screenX() {
            return window.fingerprint.screen.screenX
        }

        get pageXOffset() {
            return window.fingerprint.screen.pageXOffset
        }

        get pageYOffset() {
            return window.fingerprint.screen.pageYOffset
        }

        get devicePixelRatio() {
            return window.fingerprint.screen.devicePixelRatio
        }

        get clientWidth() {
            return window.fingerprint.screen.clientWidth
        }

        get clientHeight() {
            return window.fingerprint.screen.clientHeight
        }

        get hasHDR() {
            return window.fingerprint.screen.hasHDR
        }

    }

    Object.defineProperties(Screen.prototype, {
        availWidth: {enumerable: true},
        availHeight: {enumerable: true},
        width: {enumerable: true},
        height: {enumerable: true},
        colorDepth: {enumerable: true},
        pixelDepth: {enumerable: true},
        availTop: {enumerable: true},
        availLeft: {enumerable: true},
        innerHeight: {enumerable: true},
        outerHeight: {enumerable: true},
        outerWidth: {enumerable: true},
        innerWidth: {enumerable: true},
        screenX: {enumerable: true},
        pageXOffset: {enumerable: true},
        pageYOffset: {enumerable: true},
        devicePixelRatio: {enumerable: true},
        clientWidth: {enumerable: true},
        clientHeight: {enumerable: true},
        hasHDR: {enumerable: true},
        [Symbol.toStringTag]: {value: "Screen", configurable: true}
    });
    if (globalObject[ctorRegistrySymbol] === undefined) {
        globalObject[ctorRegistrySymbol] = Object.create(null);
    }
    globalObject[ctorRegistrySymbol][interfaceName] = Screen;

    Object.defineProperty(globalObject, interfaceName, {
        configurable: true,
        writable: true,
        value: utils.proxy(Screen, 'Screen')
    });
};

const Impl = require("../window/Screen-impl.js");
